#include <CntxtCue.h>

/* ======================= Push/Pop for Cue Begin ================== */
/* Pop  front Ȃ */
/* cpStDelayCueStt
 *           
 * RAM m_ppStGroupVTableNext RAM m_ppStGroupVTableNext RAM 
 *   m_pStTaskBase             m_pStTaskBase             
 *               ROM                               ROM                           
 *                                   
 */
static const struct StGroupVTable* cpStDelayCueStt=(struct StGroupVTable*)dfEndOfList;

/* CueFast.c  cpStDelayCueStt ĝ DelayCue_whatFirst() ݂B
 * dfStartFastStt(), dfrestartFastStt() gȂʂ̂Ƃ͖B
 */

/* ======================= Erase From Delay Cue Start ================== */
void DelayCue_erase( const struct StGroupVTable* cpStGroupVTableAg)
{
    if ( (cpStGroupVTableAg->m_pStTaskBase->m_blReady == false)
      && (cpStGroupVTableAg->m_pStTaskBase->m_wdDelay != 0)
    ){
        /* Ready Cue ɃNĂȂ m_wdDelay != 0 ł̂
         * Delay Cue ɃNĂB
         */
        const struct StGroupVTable* cpStGroupVTableAt;
        const struct StGroupVTable** cppStGroupNextAt;

        for (cppStGroupNextAt = &cpStDelayCueStt
#ifdef DfVC_
           ,assert( *(unsigned int*)cppStGroupNextAt > dfEndOfList)
#endif
           ; *(unsigned int*)cppStGroupNextAt > dfEndOfList
           ; cppStGroupNextAt = cpStGroupVTableAt->m_ppStGroupVTableNext
        ){
            cpStGroupVTableAt = *cppStGroupNextAt;
            if ( cpStGroupVTableAt == cpStGroupVTableAg){
                /* ׂ StGroupVTable BDelay Cue OB */
                *cppStGroupNextAt = *(cpStGroupVTableAt->m_ppStGroupVTableNext);
                *(int*)(cpStGroupVTableAt->m_ppStGroupVTableNext) = dfUnlinked;
                return;
            }
        }
        /* m_wdDelay != 0 && m_blReady==false  TCB ݂͑Ȃ */
        assert(0);
    }   
}

/* ======================= Erase From Delay Cue End ================== */

static const struct StGroupVTable* cpReadyCueFrontStt=(struct StGroupVTable*)dfEndOfList;
static const struct StGroupVTable* cpReadyCueEndStt=dfUnlinked;

static const struct StGroupVTable* cpLoopingCueFrontStt=(struct StGroupVTable*)dfEndOfList;
static const struct StGroupVTable* cpLoopingCueEndStt=dfUnlinked;

void DelayCue_pushFront( const struct StGroupVTable* cpStGroupVTableAg)
{
    *(cpStGroupVTableAg->m_ppStGroupVTableNext) = cpStDelayCueStt;
    cpStDelayCueStt = cpStGroupVTableAg;        
}

const struct StGroupVTable* DelayCue_popFront(void)
{
    const struct StGroupVTable* pStGroupVTableAt;

    pStGroupVTableAt = cpStDelayCueStt;
    if ( ((unsigned int)cpStDelayCueStt) > dfEndOfList){
        cpStDelayCueStt = *(cpStDelayCueStt->m_ppStGroupVTableNext);
    }
    *(int*)(pStGroupVTableAt->m_ppStGroupVTableNext) = dfUnlinked;
    return pStGroupVTableAt;
}


/* m_blReady ̐ݒ ReadCue_xxxx(.) Ăяoōs */
void ReadyCue_pushBack( const struct StGroupVTable* cpStGroupVTableAg)
{
    /* do^Ɛɓ삵ȂȂ*/
    assert(cpStGroupVTableAg->m_pStTaskBase->m_blReady == false);
    if (cpStGroupVTableAg->m_pStTaskBase->m_blReady == true){
        return;
    }

    *(int*)(cpStGroupVTableAg->m_ppStGroupVTableNext) = dfEndOfList;
    if ((unsigned int)cpReadyCueFrontStt <= dfEndOfList){
        cpReadyCueFrontStt = cpStGroupVTableAg;        
        cpReadyCueEndStt = cpStGroupVTableAg;
    }else{
        *(cpReadyCueEndStt->m_ppStGroupVTableNext)
                = cpStGroupVTableAg;
        cpReadyCueEndStt = cpStGroupVTableAg;
    }
    cpStGroupVTableAg->m_pStTaskBase->m_blReady = true;
}

void ReadyCue_pushFront( const struct StGroupVTable* cpStGroupVTableAg)
{
    /* do^Ɛɓ삵ȂȂ*/
    assert(cpStGroupVTableAg->m_pStTaskBase->m_blReady == false);
    if (cpStGroupVTableAg->m_pStTaskBase->m_blReady == true){
        return;
    }
    if ( (unsigned int)cpReadyCueFrontStt <= dfEndOfList){
        *(int*)(cpStGroupVTableAg->m_ppStGroupVTableNext) = dfEndOfList;
        cpReadyCueFrontStt = cpStGroupVTableAg;        
        cpReadyCueEndStt = cpStGroupVTableAg;
    }else{
        *(cpStGroupVTableAg->m_ppStGroupVTableNext)
                = cpReadyCueFrontStt;
        cpReadyCueFrontStt = cpStGroupVTableAg;
    }
    cpStGroupVTableAg->m_pStTaskBase->m_blReady = true;
}

/* dfStartStt(.) macro ĂяoBDelay Cue ɌqĂƂ́A
 * ReadyCue_pushFront(.) ĂяoȂB̂Ƃ m_enTaskState  EnStart 
 * ɕύXAReady Cue ւ̃N CntxtCue_DecrementDelayCueStt() ɍs킹
 */
void ReadyCue_start( const struct StGroupVTable* cpStGroupVTableAg)
{
    cpStGroupVTableAg->m_pStTaskBase->m_enTaskState = EnStart_;
    if ( cpStGroupVTableAg->m_pStTaskBase->m_wdDelay == 0){
        cpStGroupVTableAg->m_pfPushFrntBk(cpStGroupVTableAg);
    }else{
        /* m_wdDealy != 0 łB Delay Cue ɐڑĂ 
         * Ready Cue ւ̐ڑ CntxtCue_DecrementDelayCueStt(.) s
         * m_wdDealy=0 ɂ̂ÂƂɍs
         */
    }
}

/* List ̃tgvfOB̗vfւ̃|C^Ԃ */
static const struct StGroupVTable* ReadyCue_popFront(void)
{
    const struct StGroupVTable* pStGroupVTableAt;

    assert( (unsigned int)cpReadyCueFrontStt > dfEndOfList);
    assert( (unsigned int)cpReadyCueEndStt > dfUnlinked);
    pStGroupVTableAt = cpReadyCueFrontStt;
    if ( (unsigned int)cpReadyCueFrontStt > dfEndOfList){
        cpReadyCueFrontStt = *(cpReadyCueFrontStt->m_ppStGroupVTableNext);
        if ( (unsigned int)cpReadyCueFrontStt <= dfEndOfList){
            *(int*)&cpReadyCueFrontStt = dfEndOfList;
            cpReadyCueEndStt = dfUnlinked;
        }
    }
    *(int*)(pStGroupVTableAt->m_ppStGroupVTableNext) = dfUnlinked;
    return pStGroupVTableAt;
}


static void LoopingCue_pushBack( const struct StGroupVTable* cpStGroupVTableAg)
{
    *(int*)(cpStGroupVTableAg->m_ppStGroupLoopingNext) = dfEndOfList;
    if ((unsigned int)cpLoopingCueFrontStt <= dfEndOfList){
        cpLoopingCueFrontStt = cpStGroupVTableAg;        
        cpLoopingCueEndStt = cpStGroupVTableAg;
    }else{
        *(cpLoopingCueEndStt->m_ppStGroupLoopingNext)
                = cpStGroupVTableAg;
        cpLoopingCueEndStt = cpStGroupVTableAg;
    }
}

static const struct StGroupVTable* LoopingCue_popFront(void)
{
    const struct StGroupVTable* pStGroupVTableAt;

    assert( (unsigned int)cpLoopingCueFrontStt > dfEndOfList);
    assert( (unsigned int)cpLoopingCueEndStt > dfUnlinked);
    pStGroupVTableAt = cpLoopingCueFrontStt;
    if ( (unsigned int)cpLoopingCueFrontStt > dfEndOfList){
        cpLoopingCueFrontStt = *(cpLoopingCueFrontStt->m_ppStGroupLoopingNext);
        if ( (unsigned int)cpLoopingCueFrontStt <= dfEndOfList){
            *(int*)&cpLoopingCueFrontStt = dfEndOfList;
            cpLoopingCueEndStt = dfUnlinked;
        }
    }
    *(int*)(pStGroupVTableAt->m_ppStGroupLoopingNext) = dfUnlinked;
    return pStGroupVTableAt;
}

/* ======================= Push/Pop for Cue End ================== */
/* cppStGroupNextA = &cpStDelayCueStt    cppStGroupNextA= .m_ppStGroupVTableNext
 *         cpStGroupVTableAt=cpStDelayCueStt   cpStGroupVTableAt
 *                                              
 *           
 * RAM m_ppStGroupVTableNext RAM m_ppStGroupVTableNext RAM 
 *   m_pStTaskBase             m_pStTaskBase             
 *               ROM                               ROM                           
 *                                   
 */

void CntxtCue_DecrementDelayCueStt(void)
{
    const struct StGroupVTable* cpStGroupVTableAt;
    /* Timeup vf Unlink ƂA̎O dfpStGroupVTableNextStt_
     * ̒lCB̂߂ *cppStGroupNextAt = ̑삪KvƂȂ
     */
    const struct StGroupVTable** cppStGroupNextAt;
    const struct StGroupVTable* cpStGroupNextAt;

    for (cppStGroupNextAt = &cpStDelayCueStt, cpStGroupVTableAt = *cppStGroupNextAt
       ; ((unsigned int)cpStGroupVTableAt) > dfEndOfList
       ; cpStGroupVTableAt = cpStGroupNextAt
    ){
        extern void TaskBase_decrement(struct StTaskBase* pStTaskBaseAg);
        enum EnmTaskState enTaskStateAt;
        cpStGroupVTableAt = *cppStGroupNextAt;
        assert( *(cpStGroupVTableAt->m_ppStGroupVTableNext)!= cpStGroupVTableAt);
        assert(cpStGroupVTableAt->m_pStTaskBase->m_blReady == false);
        assert(cpStGroupVTableAt->m_pStTaskBase->m_wdDelay > 0);

        /* *(cpStGroupVTableAt->m_ppStGroupVTableNext) = dfUnlinked ɂȂ邱Ƃ
         * ̂ cpStGroupNextAt obt@݂ĂۑĂ
         */
        cpStGroupNextAt = *(cpStGroupVTableAt->m_ppStGroupVTableNext);

        enTaskStateAt = (enum EnmTaskState)cpStGroupVTableAt->m_pStTaskBase->m_enTaskState;
        /* EnStart, EnDormant ɂȂĂƂ */
        if ( (enTaskStateAt == EnWait_)
          || (enTaskStateAt == EnLoopingWait_)
        ){
            TaskBase_decrement(cpStGroupVTableAt->m_pStTaskBase);
        }

        enTaskStateAt = (enum EnmTaskState)cpStGroupVTableAt->m_pStTaskBase->m_enTaskState;
        if ( (enTaskStateAt == EnWait_)
          || (enTaskStateAt == EnLoopingWait_)
        ){
            cppStGroupNextAt = cpStGroupVTableAt->m_ppStGroupVTableNext;
            continue;
        }else{
            /* Delay Cue OBTimeup Ă(m_blReady==true )
             * ܂ Start/Restart Ă Ready Cue ɈڂB
             *   폜̂ cppStGroupNextAt ͓ StGroupVTable* 
             * wÂ
             */
            *cppStGroupNextAt = *(cpStGroupVTableAt->m_ppStGroupVTableNext);
            /*  TCB  EnTimeup_, EnStart_, EnRestart_ ȊO̓NȂ */
            *(int*)(cpStGroupVTableAt->m_ppStGroupVTableNext) = dfUnlinked;
            /* EnRestart_  m_wdDelay ̒lێāA^XNɌoߎԂ
             * 񂹂
             */
            if ( enTaskStateAt != EnRestart_){
                cpStGroupVTableAt->m_pStTaskBase->m_wdDelay = 0;
            } 
            assert(cpStGroupVTableAt->m_pStTaskBase->m_blReady != true);
            if ( cpStGroupVTableAt->m_pStTaskBase->m_blReady != true ){
                switch ( enTaskStateAt){
                    case EnTimeup_:
                    case EnStart_:
                    case EnRestart_:{
                
                        /* Ready Cue ɃNƂAtgAAǂ瑤
                         * Ił悤 m_pfPushFrntBk ݂Ă
                         * ŒD揇ʂI㏞ł
                         */
                        cpStGroupVTableAt->m_pfPushFrntBk(cpStGroupVTableAt);
                        break;
                    }
                    default:{
                        /* EnDormant_ Ȃ΃NO邾 */
                        assert( enTaskStateAt == EnDormant_);
                    }
                }
            }
        }
        assert( *(cpStGroupVTableAt->m_ppStGroupVTableNext)!= cpStGroupVTableAt);
    } 
}


static void executeLoopingCue(void)
{
    /* IɏIꂽARestart Ă EnLoopingWait_ łȂȂĂ */
    const struct StGroupVTable* cpStGroupVTableAt;
    struct StTaskBase* pStTaskBaseAt;

    while ((unsigned int)cpLoopingCueFrontStt > dfEndOfList){
        cpStGroupVTableAt = LoopingCue_popFront();
        pStTaskBaseAt = cpStGroupVTableAt->m_pStTaskBase;

        if ( pStTaskBaseAt->m_enTaskState == EnLoopingWait_){

            /********* cntxt switch begin ******************/
            cpStGroupVTableAt->m_pfLooping(cpStGroupVTableAt);
            /********* cntxt switch end ******************/
        
        }

        /* Task Looping IƂ EnLoopingWait_ Ԃł */
        if ( pStTaskBaseAt->m_enTaskState == EnLoopingWait_){
            assert( *(int*)(cpStGroupVTableAt->m_ppStGroupLoopingNext) == dfUnlinked );
            LoopingCue_pushBack(cpStGroupVTableAt);
        }

        switch(pStTaskBaseAt->m_enTaskState){
            case EnWait_:
            case EnLoopingWait_:
                if ( (pStTaskBaseAt->m_wdDelay)
                  && ( *(int*)cpStGroupVTableAt == dfUnlinked)
                ){
                    DelayCue_pushFront(cpStGroupVTableAt);
                }
                return;
            case EnRun_:
            case EnLoopRun_:{
                *(int*)pStTaskBaseAt = 0;
                //pStTaskBaseAt->m_enTaskState = EnDormant_;
                return;
            } 
        }

    }
}

DfBool CntxtCue_ExecuteReadyCueStt(void)
{
    while ( (unsigned int)cpReadyCueFrontStt > dfEndOfList ){
        const struct StGroupVTable* cpStGroupVTableAt;
        struct StTaskBase* pStTaskBaseAt;

        enum EnmTaskState enTaskStateAt;

        cpStGroupVTableAt = ReadyCue_popFront();
        assert(cpStGroupVTableAt->m_pStTaskBase->m_blReady == true);
        pStTaskBaseAt = cpStGroupVTableAt->m_pStTaskBase;
        enTaskStateAt = (enum EnmTaskState)pStTaskBaseAt->m_enTaskState;

        /* IĂAReady Cue ɌqĂ m_blReady = false 
         * ͂ȂB
         */
        assert(cpStGroupVTableAt->m_pStTaskBase->m_blReady == true);
        assert( (cpStGroupVTableAt->m_pStTaskBase->m_enTaskState != EnRun_)
             || (cpStGroupVTableAt->m_pStTaskBase->m_enTaskState != EnLoopRun_)
             || (cpStGroupVTableAt->m_pStTaskBase->m_enTaskState != EnLoopingWait_)
        );

        /* Ô true Ƃ̂ݎs悤ɂ */
        if ( pStTaskBaseAt->m_blReady == true){
            switch (pStTaskBaseAt->m_enTaskState){
            case EnTimeup_:
            case EnStart_:
            case EnRestart_:{
                /* m_blReady = false ɂ̂ execute() ōs */
                /**************** context switch to task **********/
                cpStGroupVTableAt->m_pfExecute(cpStGroupVTableAt);
                /**************** context switch to task **********/

                switch (pStTaskBaseAt->m_enTaskState){
                    case EnWait_:
                    case EnLoopingWait_:{
                        assert( *(int*)(cpStGroupVTableAt->m_ppStGroupVTableNext) == dfUnlinked);
                        if (pStTaskBaseAt->m_wdDelay){
                            DelayCue_pushFront(cpStGroupVTableAt);
                        }
                        if ( (pStTaskBaseAt->m_enTaskState == EnLoopingWait_)
                          && ( *(int*)(cpStGroupVTableAt->m_ppStGroupLoopingNext) == dfUnlinked)
                        ){
                            LoopingCue_pushBack(cpStGroupVTableAt);
                        }
                        return true;
                    } 
                    case EnRun_:
                    case EnLoopRun_:{
                        *(int*)pStTaskBaseAt = 0;
                        //pStTaskBaseAt->m_enTaskState = EnDormant_;
                        return true;
                    }
                }
                return true;
            }
            default:
                pStTaskBaseAt->m_blReady = false;
            }
        }
    }
    
    /* Ready Cue Ȃ̂ LoopingCue s */
    executeLoopingCue();
    return false;
}


/* ======================= Push/Pop for Cue End ================== */
void CntxtCue_loadTaskParameter(const struct StGroupVTable* cpStVTableAg, void** ppInPrmAg)
{
    TyByte byAt;
    void** ppVdTaskPrmAt;
    TyByte bySizeAt;

    bySizeAt = cpStVTableAg->m_byPrmArSize; 

    ppVdTaskPrmAt = cpStVTableAg->m_ppVdPrm;
    for(byAt=0; byAt < bySizeAt ; byAt++){
        *ppInPrmAg++ = *ppVdTaskPrmAt++;
    }
}
void CntxtCue_restoreTaskParameter(const struct StGroupVTable* cpStVTableAg, void** ppVdPrmAg)
{
    TyByte byAt;
    void** ppVdTaskPrmAt;
    TyByte bySizeAt;

    ppVdTaskPrmAt = cpStVTableAg->m_ppVdPrm;
    bySizeAt = cpStVTableAg->m_byPrmArSize; 
    for(byAt=0; byAt < bySizeAt ; byAt++){
        *ppVdTaskPrmAt++ = *ppVdPrmAg++;
    }
}
