#include <STLContext.h>

using namespace std;

//=================== ClPolling begin =================================
list<ClPolling*>* ClPolling::m_pLstpClPollingStt=0;

ClPolling::ClPolling(bool blAddAg)
{
    // blAddAg == true ̂ƂɌ肵ăXgɒǉ
    if ( blAddAg == true ){
        addToList();
    }
}

list<ClPolling*>& ClPolling::getPollingListStt(void)
{
    if ( m_pLstpClPollingStt == 0){
        m_pLstpClPollingStt = new list<ClPolling*>;
    }
    return *m_pLstpClPollingStt;
}

void ClPolling::addToList(void)
{
    m_blListed = true;
    getPollingListStt().push_back(this);
}

void ClPolling::ExecutePollingGroupStt(void)
{
    list<ClPolling*>::iterator itrAt = 
    remove_if(getPollingListStt().begin()
            ,getPollingListStt().end()
            ,mem_fun(&ClPolling::polling)
    );
    getPollingListStt().erase( itrAt, getPollingListStt().end() );
}

//=================== ClPolling End =================================



//=================== ClTaskBase begin =================================
ClTaskBase::ClTaskBase(bool blLinkPollingAg, bool blStartAg)
            : ClPolling(blLinkPollingAg), m_blReady(false), m_inDelay(0)
{
    if ( blLinkPollingAg == true ){
        addToList();
    }

    if ( blStartAg == true ){
        m_enTaskState = EnDormant;
    }else{
        m_enTaskState = EnStart;
    }
}

void ClTaskBase::setDelay(int inDelayAg)
{
    int inDelayAt;
    inDelayAt = m_inDelay;
    m_inDelay = inDelayAg;
    // inDelayAt == 0 ł邱Ƃ́Adelay cue ɓo^ĂȂƂɓ
    // Bdo^邽߂ɁȀ`FbN push B
    if ( (inDelayAt == 0)
      && (inDelayAg != 0)
    ){
        getDelayCueStt().push_back(this);
    }
}

// One chip k-uOS ł addToReadyCue() ܂łz֐ɂ̂ ROM Ȃ
// z֐ decrement()  push_back  push_front ̓ނ̋@\̂ɂɑ₷B^XNƂ
// _back()/_front() Œ肷BKvLΑO decrement() 鎖őΏ
bool ClTaskBase::decrement(void)
{
    assert(m_blReady == false);
    assert( (m_enTaskState != EnRun)
         && (m_enTaskState != EnLoopRun)
    );

    if ( (m_enTaskState == EnWait)
      || (m_enTaskState == EnLoopingWait)
    ){
        assert(m_inDelay > 0);

        m_inDelay -= DfTickUnit_;
        if ( m_inDelay <= 0 ){
            m_inDelay = 0;
            m_enTaskState = EnTimeup;   
            addToReadyCue();
            return true;
        }else{
            return false;
        }
    }

    if ( m_enTaskState != EnRestart ){
        m_inDelay = 0;
    }
    if ( (m_enTaskState == EnStart)
            || (m_enTaskState == EnRestart)
    ){
        // EnRestart ɂȂ EnTimeup ɏȂBReady Cue Ɉڂ
        // ̂ŁAEnRestart Ԃ m_inDelay  decrement 邱Ƃ͂łȂ
        addToReadyCue();
    }

    // I EnDormant ɂȂ邱ƂB̂Ƃ true ԂƂ
    // DecrementGroup()  delay cue list O
    return true;
}

void ClTaskBase::Start(void)
{
    if ( m_blReady == true ){
        // m_blReady == true łAł Delay Cue ͊OĂ
        m_inDelay = 0;
        m_enTaskState = EnStart;
    }else{
        m_enTaskState = EnStart;
        if ( m_inDelay == 0){
            // Delay Cue ɓo^ĂȂ̂Œ Ready Cue ɓo^
            //ClTaskBase::start();
            addToReadyCue();
        }else{
            // Delay Cue ɓo^ĂB
            // setDelay(0); <-- m_inDelay != 0  Delay Cue ɓo^ς
            // łԂĂBŏ m_inDelay==0 ɂłȂ
            // ClDelay::decrement()  Delay Cue ̖ m_inDelay = 0
            //  Ready Cue ւ̓o^s
        }
    }
}

void ClTaskBase::restart(void)
{
    // restart ł̂ m_enTaskState  EnWait ܂ EnLoopingWait ̂Ƃ
    // restart() ̃C[vŕ񔭍słB̂Ƃ͍ŏ
    // sꂽ restart ̂܂܂ƂȂB
    // EnTimeup ォ restart  EnRestart ɕύX邱Ƃ͂łȂ
    // Ready Cue ւ̓do^ɂȂĂ܂炾B

    //IĂ^XNX^[gƉs邩ۏ؂Ȃ 
    //s̃^XNAɑ΂ restart(.) vłȂ
    //Start/Dormant ̏Ԃ烊X^[gĂ߂AhXȂ
    // Run/LoopRun Ԃ̃X^[gƁAC[vAReady Cue 
    // `FbN鏊܂ł̓r܂ł̃[vɌ肳Ă܂^C~Oł
    assert( (m_enTaskState != EnRun)
         && (m_enTaskState != EnDormant)
         && (m_enTaskState != EnStart)
         && (m_enTaskState != EnLoopRun)
    );

    if ( (m_enTaskState == EnTimeup)
      || (m_enTaskState == EnRestart)
      || (m_enTaskState == EnLoopingWait)
      || (m_enTaskState == EnWait)
    ){
        m_enTaskState = EnRestart;
        //assert(m_blReady == false); restart() AĔs邱Ƃ
        if ( m_inDelay != 0){
            addToReadyCue();
        }else{
            // fB[쒆ɃX^[gƂ ClDelay::decrement
            //  delay cue  unlink sB̂Ƃ Ready Cue
            //  decrement() ֐̒œo^B邱ƂŁA
            // CPU Ԃ̂ list ̍ŏŌ܂ł̌ȂB
        }
    }
}

void ClTaskBase::terminate(void)
{
    // setDelay(0); <-- m_inDelay != 0  Delay Cue ɓo^ς
    // łԂĂBŏ m_inDelay==0 ɂłȂ
    m_enTaskState = EnDormant;
}


//------------  Groupt  Beigin --------------
// immediatelyStart(.) 邽߂ɂ Run ɂ̂́Aʂ execute() łB
void ClTaskBase::ExecuteReadyCueStt(void)
{
    if ( getReadyCueStt().size() ){
        ClTaskBase* pClTaskBaseAt = *(getReadyCueStt().begin() );
        getReadyCueStt().pop_front();
        // execute() ̒ cue list ̗vfȂ邱ƂB
        // task ̏eɂB̂ߐɃXgOB
        if ( (pClTaskBaseAt->m_enTaskState == EnTimeup)
          || (pClTaskBaseAt->m_enTaskState == EnStart)
          || (pClTaskBaseAt->m_enTaskState == EnRestart)
        ){
            /* m_blReady = false ɂ̂ execute() ōs */
            pClTaskBaseAt->execute();
            if ( pClTaskBaseAt->m_enTaskState == EnLoopingWait ){
                /*  loopingWait ŒfԂł */
                getLoopingCueStt().push_back(pClTaskBaseAt);
            }
        }else{
            pClTaskBaseAt->m_blReady = false;
        }
    }else{
        // ready cue ȂƂ ExecuteTaskLoopGroup() s
        executeLoopingCueStt();
    }
}

void ClTaskBase::executeLoopingCueStt(void)
{
    ClTaskBase* pClTaskBaseAt;

    if ( getLoopingCueStt().size() ){
        pClTaskBaseAt = *( getLoopingCueStt().begin() );
        getLoopingCueStt().pop_front();

        if ( pClTaskBaseAt->m_enTaskState == EnLoopingWait ){
            pClTaskBaseAt->executeTaskLoop();

            /* Task Looping IƂ EnLoopingWait Ԃł */
            if ( pClTaskBaseAt->m_enTaskState == EnLoopingWait ){
                getLoopingCueStt().push_back(pClTaskBaseAt);
            }
        }
    }
}

void ClTaskBase::EndStt(void)
{
    ClPolling::EndStt();

    delete m_pLstpDelayCueStt;
    delete m_pLstpReadyCueStt;
    delete m_pLstpLoopingCueStt;
}

void ClTaskBase::DecrementDelayCueStt(void)
{
    static ku int wdStt;
    if ( ++wdStt >= DfTickUnit_){
        list<ClTaskBase*>::iterator itrAt = 
        remove_if(getDelayCueStt().begin()
                , getDelayCueStt().end()
                , mem_fun(&ClTaskBase::decrement)
        );
        getDelayCueStt().erase(
                    itrAt, getDelayCueStt().end() );
    }
}


list<ClTaskBase*>* ClTaskBase::m_pLstpDelayCueStt=0;
list<ClTaskBase*>* ClTaskBase::m_pLstpReadyCueStt=0;
list<ClTaskBase*>* ClTaskBase::m_pLstpLoopingCueStt=0;

list<ClTaskBase*>& ClTaskBase::getDelayCueStt(void)
{
    if ( m_pLstpDelayCueStt == 0){
        m_pLstpDelayCueStt = new list<ClTaskBase*>;
    }
    return *m_pLstpDelayCueStt;
}

list<ClTaskBase*>& ClTaskBase::getReadyCueStt(void)
{
    if ( m_pLstpReadyCueStt == 0){
        m_pLstpReadyCueStt = new list<ClTaskBase*>;
    }
    return *m_pLstpReadyCueStt;
}


list<ClTaskBase*>& ClTaskBase::getLoopingCueStt(void)
{
    if ( m_pLstpLoopingCueStt == 0){
        m_pLstpLoopingCueStt = new list<ClTaskBase*>;
    }
    return *m_pLstpLoopingCueStt;
}

void ClTaskBase::addToReadyCue(void)
{
    assert ( (m_enTaskState == EnTimeup)
          || (m_enTaskState == EnStart)
          || (m_enTaskState == EnRestart)
    );

    if ( m_blReady == true ){
        // d Ready Cue ɐڑ邱Ƃ͂Ȃ
        return;
    }

    m_blReady = true;
    getReadyCueStt().push_back(this);
}

void ClTaskBase::addToLoopingCue(void)
{
    // s̃^XN炵ĂяoȂ
    assert( (m_enTaskState == EnRun)
         || (m_enTaskState == EnLoopingWait)
    );

    getLoopingCueStt().push_back(this);
}

//------------  Groupt  End --------------
//=================== ClTaskBase End =================================


//=================== ClTimeup Begin =================================
void ClTimeup::execute(void)
{
    assert(m_blReady == true);
    m_enTaskState = EnRun;
    m_blReady = false;

    task();

    if ( m_enTaskState == EnRun ){
        // ^XN߂ĂƂ EnRUN ԂłAI
        // Ȃ Delay Cue ɓo^ĂȂۏ؂
        assert(m_inDelay == 0);
        setDelay(0);   // clear delay value
        terminate();
    }
}

//=================== ClTimeup End =================================



//=================== ClStkFrmCntxt Begin =================================
void ClStkFrmCntxt::execute(void)
{
    if ( m_blReady == true ){
        int inDamieArgAt = 0x55;
        // debug lefted. stack  this AhXݒ肷
        m_ppClStkFrmCntxt = (ClStkFrmCntxt**)(&inDamieArgAt - 1);
        if ( m_enTaskState == EnStart){
            m_enTaskState = EnRun;
            m_blReady = false;
            task();
        }else{
            //m_enTaskState = EnRun;
            m_blReady = false;
            return2Task();  // task() ĂяoƓl return address X^bNɐς
        }

        if ( m_enTaskState == EnRun){
            // ^XN߂ĂƂ EnRUN ԂłAI
            // Ȃ Delay Cue ɓo^ĂȂۏ؂
            assert(m_inDelay == 0);
            setDelay(0);
            terminate();
        }
    }
}



ClTaskBase::EnmTaskState ClStkFrmCntxt::wait(int inDelayAg)
{
    assert(inDelayAg >= 0);
    assert( ( m_enTaskState == EnRun)
         || ( m_enTaskState == EnLoopRun)
    );

    m_enTaskState = EnWait;
    setDelay(inDelayAg);

    m_stStackFrame.m_inTimeUpAddress = *(int*)((&inDelayAg)-1);
    //m_inEBP_ESP = 0xaa;  // test instruction to make assembler code
    //m_ppStackFrame = (ClPcStlCntxt**)3;  // address mF̂߂ɃeXg
    // context switch for task
    // return address ȊO VC task context Z[u
#ifdef DfVC_
    __asm{
        mov  edx, dword ptr [this]
        mov       dword ptr [edx+20h],ebx        // m_inEBX = ebx
        mov       dword ptr [edx+24h],esi        // m_inESI = esi
        mov       dword ptr [edx+28h],edi        // m_inEDI = edi
            
        // bp = SP+m_inEBP_ESP  (12)
        // ClPcStlCntxt::wait ĂяoO ebp-esp 
        // this->m_inEBP_ESP ɋL^
        mov ecx,[ebp]        // wait(E) ɗO ebp ̒l
        sub ecx,esp
        // 7*4 ̓X^bNɐς܂Ă edi, esi, ebx, this, ebp, return address
        // , inDelayAg
        // ␳邽߂ɕKvł
        sub ecx,7*4
        mov dword ptr [edx+1ch],ecx               //  m_inEBP_ESP == ecx
    
        // task(void) ĂяȍԂɂāA
        // pop ebp, ret s
        mov ecx, dword ptr[edx+2ch]     //ecx = m_ppClStkFrmCntxt
        sub ecx, 8
        //mov ebp,ecx
        // SP  intrTask(.,.) Ăяo push ebp Ԃɂ
        mov esp,ecx 
    
        pop ebp
        /* Ăяoɖ߂*/
        ret
    }
#endif  // DfVC_
#ifdef DfGcc_
    //coding lefted -- gcc assember context switch code
#endif  // DfGcc_

    return EnTimeup;               // demie return value;
}

ClTaskBase::EnmTaskState ClStkFrmCntxt::doTaskPolling(int inDelayAg)
{
    assert(inDelayAg >= 0);
    assert( ( m_enTaskState == EnRun)
         || ( m_enTaskState == EnLoopRun)
    );

    if ( m_enTaskState == EnRun ){
        setDelay(inDelayAg);
    }
    m_enTaskState = EnLoopingWait;

    m_stStackFrame.m_inTimeUpAddress = *(int*)((&inDelayAg)-1);
    //m_inEBP_ESP = 0xaa;  // test instruction to make assembler code
    //m_ppStackFrame = (ClPcStlCntxt**)3;  // address mF̂߂ɃeXg
    // context switch for task
    // return address ȊO VC task context Z[u
#ifdef  DfVC_
    __asm{
        mov  edx, dword ptr [this]
        mov       dword ptr [edx+20h],ebx        // m_inEBX = ebx
        mov       dword ptr [edx+24h],esi        // m_inESI = esi
        mov       dword ptr [edx+28h],edi        // m_inEDI = edi
            
        // bp = SP+m_inEBP_ESP  (12)
        // ClPcStlCntxt::wait ĂяoO ebp-esp 
        // this->m_inEBP_ESP ɋL^
        mov ecx,[ebp]        // wait(E) ɗO ebp ̒l
        sub ecx,esp
        // 7*4 ̓X^bNɐς܂Ă edi, esi, ebx, this, ebp, return address
        // , inDelayAg
        // ␳邽߂ɕKvł
        sub ecx,7*4
        mov dword ptr [edx+1ch],ecx               //  m_inEBP_ESP == ecx
    
        // task(void) ĂяȍԂɂāA
        // pop ebp, ret s
        mov ecx, dword ptr[edx+2ch]     //ecx = m_ppClStkFrmCntxt
        sub ecx, 8
        //mov ebp,ecx
        // SP  intrTask(.,.) Ăяo push ebp Ԃɂ
        mov esp,ecx 
    
        pop ebp
        /* Ăяoɖ߂*/
        ret
    }
#endif  // DfVC_
#ifdef DfGcc_
    //coding lefted -- gcc assember context switch code
#endif  // DfGcc_

    return EnTimeup;               // demie return value;
}

void ClStkFrmCntxt::return2Task(void)
{
#ifdef  DfVC_
    __asm{
        mov edx,[this]
        mov ebx,dword ptr [edx+20h]   // ebx = m_inEBX
        mov esi,dword ptr [edx+24h]   // esi = m_inESI
        mov edi,dword ptr [edx+28h]   // edi = m_inEDI

        mov ecx,dword ptr [edx+1ch]   // ecx = m_EBP-ESP
        mov esp, ebp
        sub esp, ecx        // set task esp
        add esp, 4

        mov ecx,dword ptr [ebp+8]     // this pointer
        push ecx

        mov ecx,[edx+18h]   // m_inTimeUpAddress:time up address
        push ecx

        mov eax, 0x00000006  // EnRun
        xchg eax,[edx+8h]   // m_enTaskState
        ret
    }
#endif  // DfVC_
#ifdef DfGcc_
    //coding lefted -- gcc assember context switch code
#endif  // DfGcc_
}

void ClStkFrmCntxt::return2LoopTask(void)
{
#ifdef  DfVC_
    __asm{
        mov edx,[this]
        mov ebx,dword ptr [edx+20h]   // ebx = m_inEBX
        mov esi,dword ptr [edx+24h]   // esi = m_inESI
        mov edi,dword ptr [edx+28h]   // edi = m_inEDI

        mov ecx,dword ptr [edx+1ch]   // ecx = m_EBP-ESP
        mov esp, ebp
        sub esp, ecx        // set task esp
        add esp, 4

        mov ecx,dword ptr [ebp+8]     // this pointer
        push ecx

        mov ecx,[edx+18h]   // m_inTimeUpAddress:time up address
        push ecx

        mov  eax, 0x00000007  // EnLoopRun
        xchg eax,[edx+8h]   // m_enTaskState
        ret
    }
#endif  // DfVC_
#ifdef DfGcc_
    //coding lefted -- gcc assember context switch code
#endif  // DfGcc_
}

void ClStkFrmCntxt::executeTaskLoop(void)
{
    // m_blReady==true Ȃ΁ATask Loop ͎sȂ
    assert (m_blReady == false);

    if ( m_enTaskState == EnLoopingWait ){
        int inDamieArgAt = 0x33;
        // debug lefted for Loop Polling context change
        //m_enTaskState = EnLoopRun;
        // debug lefted. stack  this AhXݒ肷
        m_ppClStkFrmCntxt = (ClStkFrmCntxt**)(&inDamieArgAt - 1);
        return2LoopTask();  // task() ĂяoƓl return address X^bNɐς

        if ( m_enTaskState == EnLoopingWait){
            return;
        }

        if ( (m_enTaskState == EnRun)
          || (m_enTaskState == EnLoopRun)
        ){
            terminate();
        }else{
            assert(0);
        }
    }
}


ClStkFrmCntxt::ClStkFrmCntxt(bool blLinkPollingAg, int inStackSizeAg,bool blStartAg)
        : ClTaskBase(blLinkPollingAg,blStartAg)
{
    int* pInStackAt;

    pInStackAt = new int[1+(inStackSizeAg*sizeof(ClStkFrmCntxt)/sizeof(int))];
    *(int*)&m_pClStkFrmCntxt 
            = ((int)pInStackAt)+(inStackSizeAg*sizeof(ClStkFrmCntxt)/sizeof(int));
}


// Stack control belogned to each Task --- begin
int ClStkFrmCntxt::call( int(ClStkFrmCntxt::*pfAg)(void) )
{
    m_pClStkFrmCntxt--;
    // V߂AhXݒ肷BO̖߂AhX̓^XNEX^bNɕۑĂ
    m_inReturnAddress = *(((int*)&pfAg)-1);
    
    //m_inEBP_ESP = esp-ebp;
#ifdef  DfVC_
    __asm{
        mov eax, dword ptr [this]
        mov ecx,[ebp]        // call0Prm(E) ɗO ebp ̒l
        sub ecx,esp
        // 7*4 ̓X^bNɐς܂Ă edi, esi, ebx, ecx, ebp, return
        // , pfAg
        // ␳邽߂ɕKvł
        sub ecx,7*4
        // m_inEBP_ESP  private member Iɐݒ肷
        mov dword ptr [eax+1ch],ecx               //  m_BP_SP == ecx
    }
#endif  // DfVC_
#ifdef DfGcc_
    //coding lefted -- gcc assember context switch code
#endif  // DfGcc_

    *m_pClStkFrmCntxt = *this;

    // make stack frame and go to *pfAg()
#ifdef  DfVC_
    __asm{
        mov ecx,[this]              // ecx ɂ this 
        mov esp,[ecx+2ch]            // esp = m_ppClStkFrmCntxt
        sub esp, 8                   // sp indicate m_ppStackFram -4

        mov ebp, dword ptr [pfAg]   // s
        xchg ebp, [esp]

        ret
    }
#endif  // DfVC_
#ifdef DfGcc_
    //coding lefted -- gcc assember context switch code
#endif  // DfGcc_
    return 0;   // damie instruction

}
void ClStkFrmCntxt::returnFromTaskSub(int inReturnValAg)
{
    *this = *m_pClStkFrmCntxt;
    m_pClStkFrmCntxt++;
#ifdef  DfVC_
    __asm{
        mov ecx, dword ptr [this]
        mov ebx, dword ptr [ecx+20h]       // [ecx+20h] == m_inEBX
        mov esi, dword ptr [ecx+24h]       //          == m_inESI
        mov edi, dword ptr [ecx+28h]       //          == m_inEDI
        
        mov eax, [inReturnValAg]

        mov ebp, [ecx+2ch]            // 0x2c == m_ppClStkFrmCntxt offset
        sub ebp, 8                    // ebp == m_ppStackFram - 8 = 12ff2c

        mov esp, ebp
        sub esp, [ecx + 1ch]          // 1ch:m_inEBP_ESP offset
        mov edx, [ecx + 30h]          // 30h:m_inReturnAddress offset
        
        mov [esp], ecx                // this value in stack ݒ肷
        
        push edx                      // ߂AhXX^bNɓ
        ret
    }
#endif  // DfVC_
#ifdef DfGcc_
    //coding lefted -- gcc assember context switch code
#endif  // DfGcc_
}

// Stack control belogned to each Task --- end

//=================== ClStkFrmCntxt End =================================


//=================== ClFullCntxt Begin =================================
jmp_buf ClFullCntxt::m_jmpOsStt;

ClTaskBase::EnmTaskState ClFullCntxt::wait(int inDelayAg)
{
    EnmTaskState enAt;

    assert(inDelayAg >= 0);
    assert( ( m_enTaskState == EnRun)
         || ( m_enTaskState == EnLoopRun)
    );
    m_enTaskState = EnWait;
    setDelay(inDelayAg);

    enAt = (EnmTaskState)setjmp(m_jmpTask);
    if (!enAt){
#ifdef DfVC_
        getJmpOsStt();  // ߂l eax  m_jmpOsStt 
            // m_jmpOsStt.Registration  fs:[0] ݒ肵
            // unwind Ȃ
            // application task  context switch  setjmp/longjmp g
            // ̂ŁȂ΍􂪕KvƂȂ
            __asm{
                mov ecx, fs:[0]
                mov dword ptr[eax+0x18],ecx // 0x18 == EnRegistration * 4
            }
#endif  /* DfVC_ */
        longjmp(m_jmpOsStt,1);
    }
    return enAt;
}

ClTaskBase::EnmTaskState ClFullCntxt::loopingWait(int inDelayAg)
{
    EnmTaskState enAt;

    assert(inDelayAg >= 0);
    assert( ( m_enTaskState == EnRun)
         || ( m_enTaskState == EnLoopRun)
    );
    // Set sƂ EnWait ɂȂĂ邱Ƃۏ؂
    enAt = m_enTaskState;
    m_enTaskState = ClTaskBase::EnLoopingWait;
    if ( enAt == EnRun){
        setDelay(inDelayAg);
    }
    //addToLoopingCue();

    enAt = (EnmTaskState)setjmp(m_jmpTask);
    if (!enAt){
#ifdef DfVC_
        getJmpOsStt();  // ߂l eax  m_jmpOsStt 
            // m_jmpOsStt.Registration  fs:[0] ݒ肵
            // unwind Ȃ
            // application task  context switch  setjmp/longjmp g
            // ̂ŁȂ΍􂪕KvƂȂ
            __asm{
                mov ecx, fs:[0]
                mov dword ptr[eax+0x18],ecx
            }
#endif  /* DfVC_ */
        longjmp(m_jmpOsStt,1);
    }
    return enAt;
}

void ClFullCntxt::execute(void)
{
    if ( m_blReady == true ){
        EnmTaskState enAt;
        
        enAt = m_enTaskState;
        m_enTaskState = EnRun;
        m_blReady = false;
        if ( !setjmp(m_jmpOsStt) ){
            if ( enAt == EnStart){
                // ̃u[X̒̓RpCˑł
                // z֐Ăяo this->task() ƓɃX^bN؂ւ܂
                int inSpAt;             // stack pointer
                void(ClFullCntxt::* pfVCallAt)(void);
                inSpAt = sizeof(m_inAr) + /*sp address*/((int)m_inAr);
#ifdef  DfVC_
                pfVCallAt = task;
                _asm{
                    mov eax,[inSpAt]
                    mov esp,eax

                    lea eax, $comeAtTaskEnd // ^XN return Ŗ߂AhXݒ
                    ;push eax
                    push eax
                    
                    mov eax, dword ptr [pfVCallAt]
                    mov ecx,[this]
                    jmp eax
                  
                  $comeAtTaskEnd:  // ^XN return ߂Ŗ߂Ă
                    // m_jmpTask.Registration  fs:[0] ݒ肵
                    // unwind Ȃ
                    // application task  context switch  setjmp/longjmp g
                    // ̂ŁȂ΍􂪕KvƂȂ
                    mov eax, DWORD PTR [this]    ; this
                    add eax, 24                 ; 00000018H offset for m_setjmp
                    mov ecx, fs:[0]
                    mov dword ptr[eax+0x18],ecx
                }
#endif  // DfVC_
#ifdef DfGcc_
    //coding lefted -- gcc assember context switch code
#endif  // DfGcc_
                longjmp( m_jmpOsStt, true); 
            }else{
                assert( (enAt == EnTimeup)
                     || (enAt == EnRestart)
                );
#ifdef  DfVC_
                _asm{
                    // m_jmpTask.Registration  fs:[0] ݒ肵
                    // unwind Ȃ
                    // application task  context switch  setjmp/longjmp g
                    // ̂ŁȂ΍􂪕KvƂȂ
                    mov eax, DWORD PTR [this]    ; this
                    add eax, 24                 ; 00000018H offset for m_setjmp
                    mov ecx, fs:[0]
                    mov dword ptr[eax+0x18],ecx
                }
#endif  // DfVC_
#ifdef DfGcc_
    //coding lefted -- gcc assember context switch code
#endif  // DfGcc_
                longjmp( m_jmpTask, enAt); 
            }
        }

        if ( m_enTaskState == EnRun){
            // ^XN߂ĂƂ EnRUN ԂłAI
            // Ȃ Delay Cue ɓo^ĂȂۏ؂
            setDelay(0);
            terminate();
        }
    }
}

// true Ԃ task looping cue O
void ClFullCntxt::executeTaskLoop(void)
{
    // coding lefted 00.09.19 return2Task() ̏CɔύX͂
    // m_blReady==true Ȃ΁ATask Loop ͎sȂ
    assert (m_blReady == false);

    if ( m_enTaskState == EnLoopingWait ){
        int inDamieArgAt = 0x33;
        m_enTaskState = EnLoopRun;
        if ( !setjmp(m_jmpOsStt) ){
#ifdef  DfVC_
            _asm{
                // m_jmpTask.Registration  fs:[0] ݒ肵
                // unwind Ȃ
                // application task  context switch  setjmp/longjmp g
                // ̂ŁȂ΍􂪕KvƂȂ
                mov eax, DWORD PTR [this]    ; this
                add eax, 24                 ; 00000018H offset for m_setjmp
                mov ecx, fs:[0]
                mov dword ptr[eax+0x18],ecx
            }
#endif  // DfVC_
#ifdef DfGcc_
    //coding lefted -- gcc assember context switch code
#endif  // DfGcc_
            longjmp( m_jmpTask, EnLoopRun); 
        }

        if ( (m_enTaskState == EnLoopingWait)
          || (m_enTaskState == EnWait)
        ){
            // m_enTaskState == EnLoopingWait ̏Ԃ executeLoopingCueGroupStt()
            // ɖ߂ƁALoopingCue ̍ŌɁAēx߂
            return;
        }

        if ( (m_enTaskState == EnRun)
          || (m_enTaskState == EnLoopRun)
        ){
            terminate();
        }else{
            assert(0);
        }
    }
}

//=================== ClFullCntxt End =================================

