#include <CntxtCue.h>
#include <TaskBase.h>

void TaskBase_decrement(struct StTaskBase* pStTaskBaseAg)
{
    assert(pStTaskBaseAg->m_blReady == false);
    assert(pStTaskBaseAg->m_wdDelay > 0);

    switch ( pStTaskBaseAg->m_enTaskState){
        case EnWait_:
        case EnLoopingWait_:{
            /* }Vꖽ߂ *pStTaskBaseAg ̒lύX */
            if ( (pStTaskBaseAg->m_wdDelay != 0)
              && ( --(pStTaskBaseAg->m_wdDelay)==0 )
            ){
                *((int*)pStTaskBaseAg) 
                    =                   /* m_blReady == 0 */
                      EnTimeup_*0x1000   /* m_enTaskState = EnTimeu_p */
                    ;                   /* m_wdDelay = 0 */
            }
        }
    }
}

TyWord TaskBase_whatDelay( struct StTaskBase* pStAg)
{
    return DfTickUnit_ * ( (*(int*)pStAg ) & 0x0fff );
}

enum EnmTaskState TaskBase_whatState( struct StTaskBase* pStAg)
{
    return (enum EnmTaskState)pStAg->m_enTaskState;
}

void TaskBase_setDelay(struct StTaskBase* pStTaskBaseAg, enum EnmTaskState enAg, TyWord wdDelayAg)
{
    /*DfTickUnit_::  (10mSec) ŏƂ*/
    if ( (wdDelayAg < DfTickUnit_ )
      && (wdDelayAg != 0)
    ){
        wdDelayAg = DfTickUnit_;
    }

    /* 12bit m_delay ̈悩͂ݏoȂƂmF */
    assert( (wdDelayAg/DfTickUnit_) < 16*16*16 );

    /* m_blReady  m_enCntxtState  0 ɂ */
    *(int*)pStTaskBaseAg = (enAg<< 12) | wdDelayAg / DfTickUnit_;
}

void TaskBase_start(const struct StGroupVTable* pStGroupVTableAg)
{
    /*Ready Cue ɌqĂ^XNłĂ start 悤ɂ */
    pStGroupVTableAg->m_pStTaskBase->m_enTaskState = EnStart_;
    pStGroupVTableAg->m_pStTaskBase->m_wdDelay = 0;
    if ( *(pStGroupVTableAg->m_ppStGroupVTableNext) == dfUnlinked ){
        pStGroupVTableAg->m_pfPushFrntBk(pStGroupVTableAg);
    }
}

void TaskBase_restart(const struct StGroupVTable* pStGroupVTableAg)
{
    /* restart ł̂ m_enTaskState  EnWait_ ܂ EnLoopingWait_ ̂Ƃ
     * restart() ̃C[vŕ񔭍słB̂Ƃ͍ŏ
     * sꂽ restart ̂܂܂ƂȂB
     * EnTimeup_ ォ restart  EnRestart_ ɕύX邱Ƃ͂łȂ
     * Ready Cue ւ̓do^ɂȂĂ܂炾B
     *
     *IĂ^XNX^[gƉs邩ۏ؂Ȃ 
     *s̃^XNAɑ΂ restart(.) vłȂ
     *Start/Dormant ̏Ԃ烊X^[gĂ߂AhXȂ
     * Run/LoopRun Ԃ̃X^[gƁAC[vAReady Cue 
     * `FbN鏊܂ł̓r܂ł̃[vɌ肳Ă܂^C~Oł
     */
    assert( (pStGroupVTableAg->m_pStTaskBase->m_enTaskState != EnRun_)
         && (pStGroupVTableAg->m_pStTaskBase->m_enTaskState != EnDormant_)
         && (pStGroupVTableAg->m_pStTaskBase->m_enTaskState != EnStart_)
         && (pStGroupVTableAg->m_pStTaskBase->m_enTaskState != EnLoopRun_)
    );

    switch(pStGroupVTableAg->m_pStTaskBase->m_enTaskState){
    case EnTimeup_:
    case EnRestart_:
    case EnLoopingWait_:
    case EnWait_:
        pStGroupVTableAg->m_pStTaskBase->m_enTaskState = EnRestart_;
        if ( *(int*)pStGroupVTableAg->m_ppStGroupVTableNext == dfUnlinked){
            pStGroupVTableAg->m_pfPushFrntBk(pStGroupVTableAg);
        }else{
            /* fB[쒆ɃX^[gƂ ClDelay::decrement
             *  delay cue  unlink sB̂Ƃ Ready Cue
             *  decrement() ֐̒œo^B邱ƂŁA
             * CPU Ԃ̂ list ̍ŏŌ܂ł̌ȂB
             */
        }
    }
}
