#ifndef DfVrfySysc_H__
#define DfVrfySysc_H__
#include <Vrfy_event.h>
#include <systemc.h>
#include <string>   // if write this line befor <system.h> then error occurs
#include<TestVct.h>
#include<VrfyVar.h>

namespace kk{
    extern void StdCout(const std::string& crStrAg);


SC_MODULE(StVfSyscClk) {
    sc_in<bool> i_clk;
    //sc_in<sc_clock> i_clk;
    //sc_clock i_clk;
    virtual void doBothEdge(void){}
    SC_CTOR(StVfSyscClk)
    {
        SC_METHOD(doBothEdge);
        sensitive << i_clk; //sensitive for both edge 
        dont_initialize();
    }
};

class ClVfSyscActn;
//! ClVfSyscTestVct CX^Xێ SystemC ̃NbN
class ClVfSyscClk : public StVfSyscClk{
    //! *m_pLstpClVfSyscClkStt holds some sc_clock instances reffered by ClVfSyscActn
    //! m_pLstpClVfSyscClkStt is used before main, so it must create dynamically using new.
    static std::list<ClVfSyscClk*>* m_pLstpClVfSyscClkStt;//!< ClVfSyscClk is construct before main, so create *m_pLstpClVfSyscClkStt explicitly.
    sc_clock& m_rScClock;

    sc_time m_sctmPeoriod;
    sc_time m_sctmPosEdge;
    sc_time m_sctmNegEdge;

    bool m_blChanged;//!< make faster to indicate for each  ClVfSyscActn element to check clock count
    bool m_blChangedAfter;//

    //! ClVfSyscClk is generated by only RegistStt(.). So constructor ClVfSyscClk is private.
    ClVfSyscClk(void);
    virtual void doBothEdge(void);
    
  protected:
    //! m_lstpClVfSyscActn holds some ClVfSyscActn which reffers m_crScTime.
    std::list<ClVfSyscActn*> m_lstpClVfSyscActn;
  public:
    static void CopyToEdgeCountAfterStt(void);
    //! ClVfSyscClk 𐶐Eo^BcrStTimeAg ɓo^ς݂̂Ƃ́AClVfSyscClk CX^X pClVfSyscActnAg ݂̂o^
    static const ClVfSyscClk* RegistStt (ClVfSyscActn* pClVfSyscActnAg, sc_clock& rScClockAg);
    static bool IsCountUpStt(void);

    ClVfSyscClk(ClVfSyscActn*, sc_clock& rScClockAg);
    int m_inPosEdgeCount;
    int m_inNegEdgeCount;
    int m_inBothEdgeCount;

    int m_inPosEdgeCountAfter;
    int m_inNegEdgeCountAfter;
    int m_inBothEdgeCountAfter;

    friend ClVfSyscActn;
};


class ClVfIntfSyscSg : public ClVrfyIntfBase/* 02.01.25 ClIntfSgBase pɕύX*/{
  public:
     /* m_pClIntfSgBaseInstance  SystemC ͎gȂ */
    ClVfIntfSyscSg(void): ClVrfyIntfBase(0, "SystemC")
    {
        m_inActnNextLoopCount = cInMaxGlb;  //At ClVfIntfSyscSg, we don't use ClVrfyIntfBase::m_inActnNextLoopCount
    }
    virtual void TickSyscClock(void);
    virtual void Tick(void);
    virtual bool IsEnded(void);
    virtual TyTime GetTickTime(void) const;
    static ClVfIntfSyscSg* GetStt(void);
  private:
    static ClVfIntfSyscSg* m_pClVfIntfSyscSgStt;
    TyTime m_tmSyscNextContext;

    static void* m_pVdSyscFiberStt;
  public:
    static void CallMainFromScMain(int argc, char** argv);
    static void __stdcall launchMainFromScMainStt(void*);

    virtual void SetNextTickTimeCount(void);

// ------ 02.02.27 coding lefted of SystemC interface suspending used by RTOS task
  protected:
    TyTime m_tmSuspend;         // fAV~[VԂ
                                // 邽߁AHɓ삵ĂȂƂ
                                // Hnւ̃NbN𒆒fB
                                // NbNĊJƂAʑ͋킹Ȃ
                                // 悤ɁAvlȂقɒ

  public:
    void Suspend(TyTime tmSuspendIntervalAg)
    {
        //02.01.25 H삪 RTOS task ̃V~[Vsx点Ȃ悤ɂ邽߁A Suspned(.) 𔭍s
        //01.07.18 coding lefted TyTime ł / operator gȂ
        // m_tmSuspend  m_tmInterval ̔{ɕϊāA
        // ClVfIntfSyscSg::GetTickTime()  += Ԃ܂ő҂
        
        //m_tmSuspend = m_tmInterval*floor(tmSuspendIntervalAg/m_tmInterval);
    }

};

class ClVfSyscActn : public ClTestVct{
    //TyTime m_tmLastChange;
    //class sc_time m_sctmLastChange;
    //class sc_time m_sctmNextChange;
    const ClVfSyscClk* m_cpClVfSyscClk; //! We can't use ClVfSyscClk& , becauseAt SC_THREAD m_cpClVfSyscClk == 0 
    int GetCountFromSyscClk(void);

  protected:
    virtual bool getTestVctCommand(void);
    virtual void setTimeCountString(const std::string& crStrTimeCountAg );
    virtual std::string addTimeCountLineNum(
            const std::string& crStrAg, bool blAddFileNameAg = true);

    //!JFClVfSyscActn instance ̗ݐσNbNԂ
    //!E: whatNowCount() returns cumulative clock count of the ClVfSyscActn instance
    virtual int whatNowCount(void);
  public:
    enum EnmClockEdge { EnDontEdgeCount, EnPosEdgeCount, EnNegEdgeCount, EnBothEdgeCount} m_enClockEdge;
    //! constructor with sc_clock used SC_CMTHOD, SC_CTHREAD
    ClVfSyscActn(sc_clock& rScTmAg, const std::string crStrAg = "", EnmClockEdge enAg=EnPosEdgeCount);
    //! constructor without sc_clock used SC_THREAD 03.09.20 coding lefted
    //ClVfSyscActn(const std::string crStrAg = "");

    //! If m_inNextLoopCount <= m_crClVfSyscClk.m_in???EdgeCount and execute action stript
    bool TickCount(void);

    // set restart time according clock:m_blLastClock, m_tmLastChange and  ClTestVct::m_inNextLoopCount
    virtual void Restart(const std::string& crStrSourceIdentifyAg, const std::string& crStrWaitNameAg );

    virtual void doAtInitialVl( const std::string& crStrAg);

    //! to access 
    friend const ClVfSyscClk* ClVfSyscClk::RegistStt (ClVfSyscActn* pClVfSyscActnAg, sc_clock& rStTimeAg);
};

//-------------- tfNew.... template funciton begin for SystemC -----------
template<class T>
class TcVfScSgnl : public ClBaseVerified{
    sc_signal<T>& m_rSgnl;
  public:
    TcVfScSgnl(sc_signal<T>& rSgnlAg, const std::string& crStrAg
    ): m_rSgnl(rSgnlAg), ClBaseVerified(crStrAg,std::ios::hex){}

    virtual void Set(const std::string& crStrAg)
    {
        ikStream iStrmAt(crStrAg);
        T tAt;
        iStrmAt >> tAt;
        m_rSgnl.write(tAt);
    }
    virtual std::string WhatValue(void)
    {
        std::ostringstream ostrmAt;
        if (m_lgIosFlag != 0){  // ios::basefield or ios::floatfield is set
            ostrmAt.unsetf(std::ios::basefield | std::ios::floatfield);
            ostrmAt.setf(m_lgIosFlag);
        }
        ostrmAt << m_rSgnl.read();
        return ostrmAt.str();
    }

    virtual bool Compare(const std::string& crStrAg)
    {
        ikStream iStrmAt(crStrAg);
        T tAt;
        iStrmAt >> tAt;
        return  m_rSgnl.read() == tAt;
    }
};

template<class T> 
TcVfScSgnl<T>* tfNewVfScSgnl(sc_signal<T>& rTAg, const std::string& crStrAg)
{
    return new TcVfScSgnl<T>(rTAg, crStrAg);
}

template<class T>
class TcMnScSgnl : public ClBaseMonitored{
  protected:
    const T& m_crT;
    T m_T;
  public:
    struct StP : public sc_signal<T>{
        // read new_val
        static T& p( sc_signal<T>& rScSgnlAg )
        {
            return rScSgnlAg.m_new_val;
        }
    };
    TcMnScSgnl(const T& crTAg, const std::string& crStrAg
            , bool blPermanentAg=true, long lgFlagAg=std::ios::hex)
            : ClBaseMonitored(crStrAg,blPermanentAg, lgFlagAg)
            , m_crT(crTAg), m_T(crTAg){}
    virtual bool Monitor(void)
    {
        if ( m_crT == m_T ){
            return  false;
        }else{
            m_T = m_crT;
            return true;
        }
    }
    virtual std::string WhatValue(void)
    {
        std::ostringstream ostrmAt;
        if (m_lgIosFlag != 0){  // ios::basefield or ios::floatfield is set
            ostrmAt.unsetf(std::ios::basefield | std::ios::floatfield);
            ostrmAt.setf(m_lgIosFlag);
        }
        if (m_lgIosFlag & std::ios::hex){
            // hex format is requested
            ostrmAt << "0x";
        }
        ostrmAt << m_T;
        return ostrmAt.str();
    }
};


}   // nmespace kk

//-------------- special version template class end -------------------------

#endif  //DfVrfySysc_H__

